<html>
<head>
<title>OgreGLESHardwareBufferManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_9e680f2cca56003d76c91ad8153c6d1e.html">GLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_2b7861191a86db021136edf07f6d3897.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLESHardwareBufferManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLESHardwareBufferManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2008 Renato Araujo Oliveira Filho &lt;renatox@gmail.com&gt;</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00011"></a>00011 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00012"></a>00012 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00013"></a>00013 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00014"></a>00014 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00015"></a>00015 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00018"></a>00018 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00021"></a>00021 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00022"></a>00022 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00023"></a>00023 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00024"></a>00024 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00025"></a>00025 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00026"></a>00026 <span class="comment">THE SOFTWARE.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __GLESHardwareBufferManager_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __GLESHardwareBufferManager_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLESPrerequisites_8h.html">OgreGLESPrerequisites.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBufferManager_8h.html">OgreHardwareBufferManager.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037     <span class="comment">// Default threshold at which glMapBuffer becomes more efficient than glBufferSubData (32k?)</span>
<a name="l00038"></a><a class="code" href="OgreGLESHardwareBufferManager_8h.html#a9352af7e239ee4b91a6b25dba51c0f32">00038</a> <span class="preprocessor">    #   define OGRE_GL_MAP_BUFFER_THRESHOLD (1024 * 32)</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00041"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html">00041</a>     <span class="keyword">class </span><a class="code" href="OgreGLESPrerequisites_8h.html#aacfbc6e9783463d78a54316f63943b0a">_OgreGLESExport</a> <a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html" title="Implementation of HardwareBufferManager for OpenGL ES.">GLESHardwareBufferManagerBase</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043         <span class="keyword">protected</span>:
<a name="l00044"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html#a289c2f4701a63e65c239cc664d49ad88">00044</a>             <span class="keywordtype">char</span>* <a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html#a289c2f4701a63e65c239cc664d49ad88">mScratchBufferPool</a>;
<a name="l00045"></a>00045             <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mScratchMutex)
<a name="l00046"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html#a55e0e96419abad3d620162b20bde8c6c">00046</a>             size_t mMapBufferThreshold;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048         public:
<a name="l00049"></a>00049             <a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html" title="Implementation of HardwareBufferManager for OpenGL ES.">GLESHardwareBufferManagerBase</a>();
<a name="l00050"></a>00050             virtual ~GLESHardwareBufferManagerBase();
<a name="l00052"></a>00052             <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> createVertexBuffer(<span class="keywordtype">size_t</span> vertexSize,
<a name="l00053"></a>00053                 <span class="keywordtype">size_t</span> numVerts, <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>::Usage usage, <span class="keywordtype">bool</span> useShadowBuffer = false);
<a name="l00055"></a>00055             <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> createIndexBuffer(
<a name="l00056"></a>00056                 <a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>::IndexType itype, <span class="keywordtype">size_t</span> numIndexes,
<a name="l00057"></a>00057                 <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>::Usage usage, <span class="keywordtype">bool</span> useShadowBuffer = false);
<a name="l00059"></a>00059             <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">RenderToVertexBufferSharedPtr</a> createRenderToVertexBuffer();
<a name="l00060"></a>00060 
<a name="l00062"></a>00062             static GLenum getGLUsage(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> usage);
<a name="l00063"></a>00063 
<a name="l00065"></a>00065             static GLenum getGLType(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> type);
<a name="l00066"></a>00066 
<a name="l00074"></a>00074             <span class="keywordtype">void</span>* allocateScratch(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> size);
<a name="l00075"></a>00075 
<a name="l00077"></a>00077             <span class="keywordtype">void</span> deallocateScratch(<span class="keywordtype">void</span>* ptr);
<a name="l00078"></a>00078 
<a name="l00081"></a>00081             <span class="keywordtype">size_t</span> getGLMapBufferThreshold() const;
<a name="l00082"></a>00082             <span class="keywordtype">void</span> setGLMapBufferThreshold( const <span class="keywordtype">size_t</span> value );
<a name="l00083"></a>00083     };
<a name="l00084"></a>00084 
<a name="l00086"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html">00086</a>     class <a class="code" href="OgreGLESPrerequisites_8h.html#aacfbc6e9783463d78a54316f63943b0a">_OgreGLESExport</a> <a class="code" href="classOgre_1_1GLESHardwareBufferManager.html" title="GLESHardwareBufferManagerBase as a Singleton.">GLESHardwareBufferManager</a> : public <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>
<a name="l00087"></a>00087     {
<a name="l00088"></a>00088     <span class="keyword">public</span>:
<a name="l00089"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#ac792eadd5c93636fbeb839372e41ca22">00089</a>         <a class="code" href="classOgre_1_1GLESHardwareBufferManager.html" title="GLESHardwareBufferManagerBase as a Singleton.">GLESHardwareBufferManager</a>()
<a name="l00090"></a>00090             : HardwareBufferManager(<a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> GLESHardwareBufferManagerBase()) 
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092 
<a name="l00093"></a>00093         }
<a name="l00094"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#a75cbf743d851ef55fba0211cc4bab422">00094</a>         ~<a class="code" href="classOgre_1_1GLESHardwareBufferManager.html" title="GLESHardwareBufferManagerBase as a Singleton.">GLESHardwareBufferManager</a>()
<a name="l00095"></a>00095         {
<a name="l00096"></a>00096             <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> mImpl;
<a name="l00097"></a>00097         }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00102"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#a1ac4aab6d8a540a543e26daad997f587">00102</a>         <span class="keyword">static</span> GLenum getGLUsage(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> usage) 
<a name="l00103"></a>00103         { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html#a4066d00c65c8a0e2d652fb2aef1360e0" title="Utility function to get the correct GL usage based on HBU&#39;s.">GLESHardwareBufferManagerBase::getGLUsage</a>(usage); }
<a name="l00104"></a>00104 
<a name="l00106"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#a40418019f85395c7cb9c463ea8380af0">00106</a>         <span class="keyword">static</span> GLenum getGLType(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> type)
<a name="l00107"></a>00107         { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1GLESHardwareBufferManagerBase.html#a518b91e0332ef9f8194dd18cf7541a2b" title="Utility function to get the correct GL type based on VET&#39;s.">GLESHardwareBufferManagerBase::getGLType</a>(type); }
<a name="l00108"></a>00108 
<a name="l00116"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#a2112edde3090cf9fe6da73e2db6b9104">00116</a>         <span class="keywordtype">void</span>* allocateScratch(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> size)
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118             <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>GLESHardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;allocateScratch(size);
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120 
<a name="l00122"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#a181460d6b10e32a3d5ea469ae14b1e5b">00122</a>         <span class="keywordtype">void</span> deallocateScratch(<span class="keywordtype">void</span>* ptr)
<a name="l00123"></a>00123         {
<a name="l00124"></a>00124             <span class="keyword">static_cast&lt;</span>GLESHardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;deallocateScratch(ptr);
<a name="l00125"></a>00125         }
<a name="l00128"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#a08ebfd016ffd6afb99911d243ba132f0">00128</a>         <span class="keywordtype">size_t</span> getGLMapBufferThreshold()<span class="keyword"> const</span>
<a name="l00129"></a>00129 <span class="keyword">        </span>{
<a name="l00130"></a>00130             <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>GLESHardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;getGLMapBufferThreshold();
<a name="l00131"></a>00131         }
<a name="l00132"></a><a class="code" href="classOgre_1_1GLESHardwareBufferManager.html#a53818c062ef695fcb8ff4b500655879a">00132</a>         <span class="keywordtype">void</span> setGLMapBufferThreshold( <span class="keyword">const</span> <span class="keywordtype">size_t</span> value )
<a name="l00133"></a>00133         {
<a name="l00134"></a>00134             <span class="keyword">static_cast&lt;</span>GLESHardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;setGLMapBufferThreshold(value);
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     };
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
